<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use DB;
use Session;
use Redirect;

use App\Mail\ContactMessage;
use App\Mail\Brochure;
use App\Mail\Enquiry;
use Illuminate\Support\Facades\Mail;

class PagesController extends Controller
{
    public function index(){
        $title = 'Home - Fresh Gold Kenya';
        return view('index',['title'=>$title]);
    }


    public function about(){
        $title = 'About Fresh Gold Kenya - Kenyan Based Flowers Exporter';
        return view('about',['title'=>$title]);
    }


    public function contact(){
        $title = 'Contact Us - Fresh Gold Kenya';
        return view('contact',['title'=>$title]);
    }

    public function csr(){
        $title = ' Corporate Social Responsibility - Fresh Gold Kenya';
        return view('csr',['title'=>$title]);
    }

    public function gallery(){
        $title = ' Gallery - Fresh Gold Kenya';
        return view('gallery',['title'=>$title]);
    }


    public function roses(){
        $title = 'Roses - Fresh Gold Kenya';
        return view('roses',['title'=>$title]);
    }


     public function videos(){
        $title = 'Videos - Fresh Gold Kenya';
        return view('videos',['title'=>$title]);
    }

     public function product_categories(Request $request){
        $filter_color = $request->color;
        $title = 'Fresh Gold Kenya Roses';

        if($filter_color=='all'){
            $result = DB::select('select * from products ');
        }else{
            $result = DB::select('select * from products where color=? ',[$filter_color]);   
        }

        
        $result_2 = DB::select('select color from products group by color ');

        $colors = [];
        foreach($result_2 as $r){
            $color2 = '';

            if($r->color=='Bicolour yellow|Orange'){
                $color2 = 'orange';
            }


            if($r->color=='Bicolour orange'){
                $color2 = 'orange';
            }


            if($r->color=='Bicolour white|pink'){
                $color2 = 'pink';
            }

            if($r->color=='Orange'){
                $color2 = 'orange';
            }


            if($r->color=='Cream white'){
                $color2 = 'white';
            }

            if($r->color=='Red'){
                $color2 = 'red';
            }

            if($r->color=='Light Pink'){
                $color2 = 'pink';
            }

            if($r->color=='Yellow'){
                $color2 = 'yellow';
            }


            if($r->color=='Bicolour white|pink'){
                $color2 = 'pink';
            }

             if($r->color=='Cerise'){
                $color2 = 'pink';
            }

            if($r->color=='White'){
                $color2 = 'white';
            }

             if($r->color=='Lavender'){
                $color2 = 'purple';
            }


            if($r->color=='Cream pink'){
                $color2 = 'pink';
            }

            $a = array('color_1'=>$r->color, 'color_2'=>$color2 );

            array_push($colors, $a);
        }

        return view('product-categories',['title'=>$title, 'products'=>$result, 'colors'=>$colors ]);
    }

     public function product_details(Request $request){
        
        $result = DB::select('select * from products where id=? ',[$request->id]);
        $gallery = DB::select('select * from gallery where product_id=? ',[$request->id]);

        foreach($result as $r){

            $name = $r->name;
            $color = $r->color;
            $head_size = $r->head_size;
            $breeder = $r->breeder;
            $flower_size = $r->flower_size;
            $bud_height = $r->bud_height;
            $stem_length = $r->stem_length;
            $image = $r->image;
            $id = $r->id;

        }

        $title = $name.' - Fresh Gold Kenya';

        return view('product-details',['title'=>$title,'name'=>$name, 'color'=>$color, 'head_size'=>$head_size, 'image'=>$image, 'id'=>$id, 'gallery'=>$gallery, 'breeder'=>$breeder, 'flower_size'=>$flower_size, 'bud_height'=>$bud_height, 'stem_length'=>$stem_length ]);
    }

     public function add_product(){
        $title = 'Add Product - Fresh Gold Kenya';
        return view('add-product',['title'=>$title, 'message'=>'']);
    }


    public function save_product(Request $request){
        $title = 'Add Product - Fresh Gold Kenya';

        $image=time().rand(1000,1000000).'.'.$request->image->extension();

    DB::insert('insert into products(name,color,head_size,image) values(?,?,?,?) ',[$request->name, $request->color, $request->head_size, $image]);

    $req=$request->image->move('assets/images/products/', $image);

        return Redirect::to('/add-product')->with('message','Product added successfully!');

    }



    public function enquiry(Request $request){
        $title = 'Enquiry sent! - Fresh Gold Kenya';

        $details = ['full_name'=>$request->full_name, 'email'=>$request->email, 'phone'=>$request->phone, 'company'=>$request->company, 'name'=>$request->name, 'color'=>$request->color, 'head_size'=>$request->head_size, 'image'=>$request->image ];

        Mail::to('noreply@freshgoldkenya.co.ke')->send(new Enquiry($details));

        return Redirect::to('/product-details/'.$request->id)->with('message','Message sent successfully');
    }


     public function send_message(Request $request){
        $title = 'Message sent! - Fresh Gold Kenya';

        $details = ['name'=>$request->name, 'email'=>$request->email, 'phone'=>$request->phone, 'message'=>$request->message];

        Mail::to('noreply@freshgoldkenya.co.ke')->send(new ContactMessage($details));

        return Redirect::to('/contact')->with('message','Message sent successfully');
    }


     public function brochure(Request $request){
        $title = 'Message sent! - Fresh Gold Kenya';

        $details = ['name'=>$request->name, 'email'=>$request->email, 'phone'=>$request->phone, 'product'=>$request->product];

        Mail::to('noreply@freshgoldkenya.co.ke')->send(new Brochure($details));

        return Redirect::to('/#message')->with('message','Message sent successfully');
    }





 public function login(){
        $title = 'Login - Fresh Gold Kenya';
        return view('login',['title'=>$title]);
    }


 public function login_now(Request $request){
        $title = 'Login - Fresh Gold Kenya';

        if($request->username=='admin' && $request->password=='Password@2024'){

            return Redirect::to('/add-product');

        }else{
            return Redirect::to('/login')->with('message','Wrong username or password!');
        }

        return view('login',['title'=>$title]);
    }





 public function products(){
        $title = 'Products - Fresh Gold Kenya';

        $result = DB::select('select * from products ');

        return view('products',['title'=>$title, 'products'=>$result]);
    }



 public function view_product(Request $request){
       

        $result = DB::select('select * from products where id=? ',[$request->id]);

        if(count($result)>0){

            foreach($result as $p){

                $name = $p->name;
                $head_size = $p->head_size;
                $color = $p->color;

            }

        }

         $title = $name.' - Fresh Gold Kenya';


        return view('view-product',['title'=>$title, 'id'=>$request->id, 'head_size'=>$head_size, 'color'=>$color, 'name'=>$name ]);
    }



public function upload_gallery(Request $request){
        $title = 'Products - Fresh Gold Kenya';

        if($request->gallery){

            foreach($request->gallery as $g){

    $image=time().rand(1000,1000000).'.'.$g->extension();

    DB::insert('insert into gallery(product_id,image) values(?,?) ',[$request->id, $image]);

    $req=$g->move('assets/images/product-gallery/', $image);

            }

     


        }

        return Redirect::to('/view-product/'.$request->id)->with('message','Gallery uploaded!');

    }






 public function edit_product(Request $request){
        $title = 'Products - Fresh Gold Kenya';

        $result = DB::update(' update products set name=?, color=?, head_size=?, breeder=?, flower_size=?, bud_height=?, stem_length=? where id=? ',[ $request->name, $request->color, $request->head_size, $request->breeder, $request->flower_size, $request->bud_height, $request->stem_length, $request->id ]);

        return Redirect::to('/view-product/'.$request->id)->with('message','Changes saved!');
    }



     public function delete_product(Request $request){
        $title = 'Products - Fresh Gold Kenya';

        $gallery = DB::select('select * from gallery where product_id=? ',[$request->id]);

        if(count($gallery)>0){

            foreach($gallery as $g){

                $file = 'assets/images/product-gallery/'.$g->image;

            if(file_exists($file)){
                unlink($file);
            }

            }

        }

        DB::delete('delete from gallery where product_id=? ',[$request->id]);
        DB::delete('delete from products where id=? ',[$request->id]);

        return Redirect::to('/products');
    }



    public function search(Request $request){
        $title = 'Search Results - Fresh Gold Kenya';


        $result = DB::select('select * from products where name like :search_text  order by created desc ', array( 'search_text' => '%'.$request->search_text.'%') );

        return view('search-results',['products'=> $result, 'title'=>$title, 'search_text'=>$request->search_text ]);
    }



}
